import random


class Game:
    def __init__(self, grid_size) -> None:
        self.grid_size = grid_size
        self.grid = [[i for i in range(grid_size)] for j in range(grid_size)]
        self.player_coord = [0, 0]
        self.player_length = 1
        self.lost = False
        self.current_direction = "right"
        self.candy = self.new_candy()

    def move(self, direction):
        
        # the snake can't make a U turn 
        if(direction == "left arrow" and self.current_direction == "right"
           or direction == "right arrow" and self.current_direction == "left"
           or direction == "up arrow" and self.current_direction == "down"
           or direction == "down arrow" and self.current_direction == "up"):
            return self
        
        if direction == "left arrow" and self.check_move(
            self.player_coord[0] - 1, self.player_coord[1]
        ):
            self.player_coord[0] -= 1
            self.current_direction = "left"
        elif direction == "right arrow" and self.check_move(
            self.player_coord[0] + 1, self.player_coord[1]
        ):
            self.player_coord[0] += 1
            self.current_direction = "right"
        elif direction == "up arrow" and self.check_move(
            self.player_coord[0], self.player_coord[1] - 1
        ):
            self.player_coord[1] -= 1
            self.current_direction = "up"
        elif direction == "down arrow" and self.check_move(
            self.player_coord[0], self.player_coord[1] + 1
        ):
            self.player_coord[1] += 1
            self.current_direction = "down"
        else:
            self.lost = True

        self.check_candy()

        return self

    def exit_game(self):
        self.lost = True

    """
    check if the move is still in the grid
    """

    def check_move(self, coordX, coordY):
        if (
            coordX >= 0
            and coordX <= len(self.grid) - 1
            and coordY >= 0
            and coordY <= len(self.grid[0]) - 1
        ):
            return True
        else:
            return False

    def new_candy(self):
        return [random.randint(0, self.grid_size), random.randint(0, self.grid_size)]

    def check_candy(self):
        if (
            self.player_coord[0] == self.candy[0]
            and self.player_coord[1] == self.candy[1]
        ):
            self.eat_candy()
            return True

    def eat_candy(self):
        self.player_length += 1
        self.candy = self.new_candy()
