from pythonsnake import terminalColor, model
import os


def cls():
    os.system("cls" if os.name == "nt" else "clear")


def refresh_grid(gameState: model.Game) -> None:
    grid_to_print = ""

    for coordY, line in enumerate(gameState.grid):
        # if first row, display the top border
        if coordY == 0:
            grid_to_print += "_" * len(line)
            grid_to_print += "\n"

        for coordX, column in enumerate(line):

            line_contain_candy = False
            line_contain_player = False

            # if left border, display border
            if coordX == 0:
                grid_to_print += "|"

            # display user
            if (
                coordY == gameState.player_coord[1]
                and coordX == gameState.player_coord[0]
            ):
                grid_to_print += terminalColor.OKGREEN + "X" + terminalColor.ENDC  # type: ignore
                line_contain_player = True

            # display candy except if same coord as player
            if (
                coordY == gameState.candy[1]
                and coordX == gameState.candy[0]
                and (
                    gameState.candy[1] != gameState.player_coord[1]
                    or gameState.candy[0] != gameState.player_coord[0]
                )
            ):
                grid_to_print += terminalColor.OKBLUE + "O" + terminalColor.ENDC  # type: ignore
                line_contain_candy = True

            if not line_contain_candy and not line_contain_player:
                grid_to_print += " "  # type: ignore

            # if right border, display border
            if coordX == len(line) - 1:
                grid_to_print += "|\n"

    # if first row, display the top border
    if coordY == len(gameState.grid) - 1:
        grid_to_print += "\u203E" * len(line)
        grid_to_print += "\n"

    if gameState.lost:
        grid_to_print += (
            terminalColor.FAIL
            + terminalColor.BOLD
            + terminalColor.UNDERLINE
            + "Vous avez perdu !!!"
            + terminalColor.ENDC
            + "\n"
        )

    grid_to_print += (
        terminalColor.OKCYAN
        + "pour revenir au menu, appuyer sur la touche (Esc)"
        + terminalColor.ENDC
        + "\n"
    )

    grid_to_print += (
        terminalColor.OKBLUE
        + "Longueur: "
        + str(gameState.player_length)
        + terminalColor.ENDC
    )

    cls()
    print(grid_to_print, end="\r")


def menu():
    cls()
    menu = (
        terminalColor.OKGREEN
        + terminalColor.BOLD
        + "Bienvenue dans python Snake"
        + terminalColor.ENDC
        + "\n"
        + "que souhaitez vous faire:\n"
        + "1) jouer dans la console\n"
        + "2) jouer avec une Interface\n"
        + "3) Quitter\n"
    )
    print(menu, end="\r")


def menu_choice_incorrect():
    print(terminalColor.FAIL, "le choix n'est pas correct", terminalColor.ENDC)
